
/*
    A basic extension of the java.awt.Dialog class
 */

import java.awt.*;
import java.awt.event.*;

public class AboutDialog extends Dialog
             implements ActionListener {

	public AboutDialog(Frame parent, boolean modal) {
	    super(parent, modal);
		setLayout(null);
		addNotify();
		setSize(getInsets().left + getInsets().right + 249,getInsets().top + getInsets().bottom + 150);
		setFont(new Font("Dialog", Font.BOLD, 14));
		setForeground(Color.black);
		setBackground(Color.lightGray);
		label1 = new Label("Distributed Interface");
		label2 = new Label(" for Abductive Logic Agents");
		label1.setBounds(getInsets().left + 60,getInsets().top + 24,144,21);
		label2.setBounds(getInsets().left + 36,getInsets().top + 48,180,21);
		add(label1);
		add(label2);
		okButton = new Button("OK");
		okButton.addActionListener(this);
		okButton.setBounds(getInsets().left + 96,getInsets().top + 84,66,27);
		add(okButton);
		setTitle("About");
		setResizable(false);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().getBounds();
    	Rectangle abounds = getBounds();

        setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == okButton) {
	        setVisible(false);
        }
	}

	//{{DECLARE_CONTROLS
	Label label1,label2;
	Button okButton;
	//}}
}
