/* classe che realizza l'interfaccia grafica di un agente e consente di gestire
i vari tipi di eventi compreso la possibilita' di far partire una query */

import java.awt.*;
import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import java.net.InetAddress;
import java.util.Vector;
import amzi.ls.*;
import java.awt.event.*;

public class AgentFrame extends Frame
            implements ActionListener, WindowListener {

    agentServer server=null;
    LogicServer ls;

    public AgentFrame(agentServer server) {
        this.server=server;
		setLayout(null);
		addNotify();
		setSize(getInsets().left + getInsets().right + 864,getInsets().top + getInsets().bottom + 685);
		openFileDialog1 = new FileDialog(this, "Open a knowledge-base file",FileDialog.LOAD);
		labelQuery = new Label("Query :-");
		labelQuery.setBounds(getInsets().left + 60,getInsets().top + 36,84,36);
		labelQuery.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelQuery);
		textFieldQuery = new TextField();
		textFieldQuery.setEnabled(false);
		textFieldQuery.setBounds(getInsets().left + 156,getInsets().top + 40,180,30);
		textFieldQuery.setFont(new Font("Dialog", Font.PLAIN, 16));
		add(textFieldQuery);
		buttonRun = new Button("Run query");
		buttonRun.addActionListener(this);
		buttonRun.setEnabled(false);
		buttonRun.setBounds(getInsets().left + 396,getInsets().top + 36,132,36);
		buttonRun.setFont(new Font("Dialog", Font.BOLD, 14));
		add(buttonRun);
		buttonCancel = new Button("Cancel Messages");
		buttonCancel.addActionListener(this);
		buttonCancel.setBounds(getInsets().left + 576,getInsets().top + 36,144,36);
		buttonCancel.setFont(new Font("Dialog", Font.BOLD, 14));
		add(buttonCancel);
		labelKnowBase = new Label("Knowledge base:");
		labelKnowBase.setBounds(getInsets().left + 72,getInsets().top + 108,154,20);
		labelKnowBase.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelKnowBase);
		textAreaRules = new TextArea();
		textAreaRules.setEditable(false);
		textAreaRules.setBounds(getInsets().left + 60,getInsets().top + 144,672,192);
		textAreaRules.setFont(new Font("Dialog", Font.PLAIN, 16));
		add(textAreaRules);
		labelMessages = new Label("Messages");
		labelMessages.setBounds(getInsets().left + 72,getInsets().top + 372,154,20);
		labelMessages.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelMessages);
		textAreaMessages = new TextArea();
		textAreaMessages.setEditable(false);
		textAreaMessages.setBounds(getInsets().left + 60,getInsets().top + 408,672,240);
		textAreaMessages.setFont(new Font("Dialog", Font.PLAIN, 16));
		add(textAreaMessages);
		addWindowListener(this);


         //{{INIT_MENUS
		mainMenuBar = new MenuBar();

		menuFile = new Menu("  File  ");
		menuFile.setFont(new Font("MenuFile",Font.BOLD,16));
		menuItemLoad = new MenuItem("Load rules");
		menuItemLoad.addActionListener(this);
		menuItemLoad.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuFile.add(menuItemLoad);
		menuFile.addSeparator();
		menuItemExit = new MenuItem("Exit");
		menuItemExit.addActionListener(this);
		menuItemExit.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuFile.add(menuItemExit);
		mainMenuBar.add(menuFile);

		menuSetting = new Menu("  Setting Agents ");
		menuSetting.setFont(new Font("MenuSetting",Font.BOLD,16));
		menuItemName = new MenuItem("Agent name");
		menuItemName.addActionListener(this);
		menuItemName.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuSetting.add(menuItemName);
		menuItemBlack = new MenuItem("Blackboard parameters");
		menuItemBlack.addActionListener(this);
		menuItemBlack.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuSetting.add(menuItemBlack);
		menuItemAdd = new MenuItem("Add Agent to the bunch");
		menuItemAdd.addActionListener(this);
		menuItemAdd.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuSetting.add(menuItemAdd);
		menuItemRemove = new MenuItem("Remove Agent from the bunch");
		menuItemRemove.addActionListener(this);
		menuItemRemove.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuSetting.add(menuItemRemove);
		menuItemView = new MenuItem("View the multiagent system");
		menuItemView.addActionListener(this);
		menuItemView.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuSetting.add(menuItemView);
		mainMenuBar.add(menuSetting);


		menuHelp = new Menu("  Help  ");
		menuHelp.setFont(new Font("MenuHelp",Font.BOLD,16));
		mainMenuBar.setHelpMenu(menuHelp);
        menuItemAbout = new MenuItem("About");
        menuItemAbout.addActionListener(this);
        menuItemAbout.setFont(new Font("MenuItem",Font.PLAIN,14));
		menuHelp.add(menuItemAbout);
		mainMenuBar.add(menuHelp);
		setMenuBar(mainMenuBar);
		//}}
		setTitle("            Distributed Agent Inteface   -   ");
	}


    public synchronized void setVisible(boolean v) {
        setLocation(0,0);
        super.setVisible(v);
    }

/* gestione eventi */

	public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonRun) {
            buttonRun_Clicked();
        } else
        if (source == buttonCancel) {
            buttonCancel_Clicked();
        } else
	    if (source == menuItemRemove) {
		    menuItemRemove_Action();
		} else
		if (source == menuItemView) {
			menuItemView_Action();
		} else
		if (source == menuItemBlack) {
			menuItemBlackboard_Action();
		} else
		if (source == menuItemAdd) {
			menuItemAdd_Action();
		} else
		if (source == menuItemName) {
            menuItemAgentName_Action();
		} else
		if (source == menuItemLoad) {
            Open_Action();
		} else
		if (source == menuItemAbout) {
            About_Action();
		} else
		if (source == menuItemExit) {
            Exit_Action();
		}
	}

    public void windowClosed(WindowEvent event) {
    }

    public void windowDeiconified(WindowEvent event) {
    }

    public void windowIconified(WindowEvent event) {
    }

    public void windowActivated(WindowEvent event) {
    }

    public void windowDeactivated(WindowEvent event) {
    }

    public void windowOpened(WindowEvent event) {
    }

    public void windowClosing(WindowEvent event) {
        setVisible(false);  // hide the Frame
        dispose();      // free the system resources
        System.exit(0); // close the application
    }

	void menuItemAdd_Action() {
		// create and show the Dialog
        dAdd=new DialogAddAgent(this,server,true);
	    dAdd.show();
   }

   void menuItemView_Action() {
		// create and show the Dialog
        dView=new SystemDialog(this,server,true);
	    dView.show();
   }

   void menuItemRemove_Action() {
    	//Create and show the Dialog
	    dRemove=new DialogRemove(this,server,true);
	    dRemove.show();
   }

   void menuItemBlackboard_Action() {
		// Create and show the Dialog
		dBlack=new DialogBlackboard(this,server,true);
		dBlack.show();
   }

/* esecuzione query */
   void buttonRun_Clicked() {
        if (textFieldQuery.getText().compareTo("")==0) {
            dMessage=new DialogMessages(this,true,"Impossibile far partire la query: occorre inserire un termine nel campo QUERY");
            dMessage.show();
        } else
        if (server.numberOfAgent==0) {
            dMessage=new DialogMessages(this,true,"Nessua agente remoto e' attualmente in esecuzione");
            dMessage.show();
        } else {
           System.out.println("Reset dei numCall");
		   server.resetNumCall();
		   iAgent remoteCall;
		   try {
		     for (int i=0;i<server.numberOfAgent;i++) {
		        remoteCall=(iAgent)Naming.lookup("rmi://"+server.otherMachine.elementAt(i)+":"+server.otherRegistry.elementAt(i)+"/"+server.otherAgentName.elementAt(i));
		        remoteCall.remoteResetNumCall();
		     }
		   } catch (Exception e) {e.printStackTrace();}
           String goal=textFieldQuery.getText();
           try {
             logicAgent la=new logicAgent(this,server,0);
             String risultato=la.solveAbducible(goal);
             if (risultato!=null) {
                printMessage("La query ha avuto successo,\nil risultato trovato e' "+risultato);
             } else {
                printMessage("La query e' fallita");
             }
             la.close();
           } catch (LSException e) {System.out.println(e.GetMsg());}
        }
   }

   void buttonCancel_Clicked() {
		// Clear TextAreaMessages
		textAreaMessages.setText(null);
   }

/* setting del nome dell'agente e avvio server agente */
   void menuItemAgentName_Action() {
		// Create and show as modal
		if (server.rulesLoaded) {
           dName=new DialogNameAgent(this,server,true);
           dName.show();
        } else {
            dMessage=new DialogMessages(this,true,"Prima di far partire il server occorre caricare la base di conoscenza");
            dMessage.show();
        }
   }

/* caricamento base di conoscenza */
   void Open_Action() {
		// Action from Open... Show the OpenFileDialog
		openFileDialog1.show();
		String file;
		file=openFileDialog1.getDirectory() + openFileDialog1.getFile();
		if( !(file.endsWith(".pro")) )
		{
		    return;
		}
		// load the rules
        getEntries(file);
		textFieldQuery.setEnabled(true);
		// set the server.rules variable with the .XPL version
		char [] temp=file.toCharArray();
		server.rules=String.copyValueOf(temp,0,file.length()-4)+".xpl";
		server.rulesLoaded=true;
	}

	void About_Action() {
		// Action from About Create and show as modal
		(new AboutDialog(this, true)).show();
	}

	void Exit_Action() {
		// Action from Exit

		setVisible(false);  // hide the Frame
        dispose();      // free the system resources
        System.exit(0); // close the application
	}


	//{{DECLARE_CONTROLS
    DialogAddAgent dAdd;
    DialogRemove dRemove;
    DialogNameAgent dName;
    DialogMessages dMessage;
    DialogBlackboard dBlack;
    SystemDialog dView;
	FileDialog openFileDialog1;
	TextField textFieldQuery;
	Button buttonRun,buttonCancel;
	Label labelKnowBase,labelMessages,labelQuery;
	TextArea textAreaRules, textAreaMessages;
	//}}

	//{{DECLARE_MENUS
	MenuBar mainMenuBar;
	Menu menuFile;
	MenuItem menuItemLoad,menuItemExit,menuItemAdd,menuItemRemove,menuItemView,
	         menuItemName,menuItemAbout,menuItemBlack;
	Menu menuBunch,menuSetting,menuHelp;
	//}}

    private void getEntries(String filename) {
	    try
	    {
 	        BufferedReader in;
 	        String line,str;

            textAreaRules.setText(null);
       	    in = new BufferedReader(new FileReader(filename));
       	    while ( (line=in.readLine() ) != null )
       	    {
       	        str=line+"\n";
       	        textAreaRules.append(str);
       	    }
    	}
    	catch(FileNotFoundException e)
    	{
    	    System.err.println("Can't open " + filename);
    	}
    	catch(IOException e)
    	{
    	    System.err.println("Error reading " + filename);
    	}
    }

   public synchronized void printMessage(String m) {
       textAreaMessages.append(m+"\n");
   }

   public synchronized void printVectorMessage(String m, Vector v) {
        textAreaMessages.append(m);
        showVector(v);
     }

   public void showVector(Vector v) {
       String strList="[";
       if (v.size()>0) {
           strList=strList+v.elementAt(0);
           for (int i=1;i<v.size();i++) {
              strList=strList+","+v.elementAt(i);
           }
       }
       strList=strList+"]";
       printMessage(strList);
    }

}