/* classe che realizza la finestra di dialogo per il setting del riferimento
alla blackboard condivisa */

import java.rmi.registry.*;
import java.rmi.*;
import java.rmi.server.*;
import java.awt.*;
import java.awt.event.*;

public class DialogBlackboard extends Dialog
          implements ActionListener {

    private AgentFrame parentFrame;
    private agentServer server;
    private String defaultPort="1099";

	public DialogBlackboard(AgentFrame parent, agentServer server, boolean modal) {
         super(parent, modal);
         parentFrame=parent;
         this.server=server;
         setLayout(null);
         addNotify();
         setSize(getInsets().left + getInsets().right + 497,getInsets().top + getInsets().bottom + 303);
         setFont(new Font("Dialog", Font.BOLD, 14));
         setForeground(Color.black);
		 setBackground(Color.lightGray);
         labelAgent = new Label("Blackboard name");
         labelAgent.setBounds(getInsets().left + 36,getInsets().top + 24,120,24);
         add(labelAgent);
         textFieldName = new TextField();
         textFieldName.setBounds(getInsets().left + 168,getInsets().top + 24,204,24);
         textFieldName.setFont(new Font("Dialog", Font.PLAIN, 14));
         add(textFieldName);
         labelMachine = new Label("Host machine");
         labelMachine.setBounds(getInsets().left + 36,getInsets().top + 72,108,24);
         setFont(new Font("Dialog", Font.BOLD, 14));
         add(labelMachine);
         textFieldHost = new TextField();
		 textFieldHost.setBounds(getInsets().left + 168,getInsets().top + 72,204,24);
		 setFont(new Font("Dialog", Font.PLAIN, 14));
		 add(textFieldHost);
         labelPort = new Label("Port number");
         labelPort.setBounds(getInsets().left + 36,getInsets().top + 120,108,24);
         setFont(new Font("Dialog", Font.BOLD, 14));
         add(labelPort);
         textFieldPort = new TextField(defaultPort);
         textFieldPort.setBounds(getInsets().left + 168,getInsets().top + 120,204,24);
         textFieldPort.setFont(new Font("Dialog", Font.PLAIN, 14));
         add(textFieldPort);
         group=new CheckboxGroup();
         checkbox1 = new Checkbox("politica di accesso In/Out",group,true);
		 checkbox1.setBounds(getInsets().left + 36,getInsets().top + 180,201,24);
		 add(checkbox1);
		 checkbox2 = new Checkbox("politica di accesso read/write",group,false);
		 checkbox2.setBounds(getInsets().left + 264,getInsets().top + 180,228,24);
		 add(checkbox2);
         buttonCancel = new Button("Cancel");
         buttonCancel.addActionListener(this);
         buttonCancel.setBounds(getInsets().left + 264,getInsets().top + 228,132,36);
         buttonCancel.setFont(new Font("Dialog", Font.BOLD, 14));
         add(buttonCancel);
         buttonOk = new Button("Ok");
         buttonOk.addActionListener(this);
         setTitle("Setting the blackboard parameters");
         buttonOk.setBounds(getInsets().left + 84,getInsets().top + 228,104,36);
         buttonOk.setFont(new Font("Dialog", Font.BOLD, 14));
         add(buttonOk);
	}

    public synchronized void show() {
    	Rectangle bounds = getParent().getBounds();
    	Rectangle abounds = getBounds();
    	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);
    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonOk) {
	        buttonOk_Clicked();
        } else
        if (source == buttonCancel) {
            setVisible(false);
        }
	}

	void buttonOk_Clicked() {
        setVisible(false);
        server.blackboardName=textFieldName.getText();
		server.blackboardPort=Integer.parseInt(textFieldPort.getText());
		server.blackboardHost=textFieldHost.getText();
		if (group.getCurrent()==checkbox1) {
		    server.politicaInOut=true;
		    System.out.println("Selezionata la politica In/Out");
		} else {
		    server.politicaInOut=false;
		    System.out.println("Selezionala la politica read/write");
		}
		try {
		  server.blackboard=(iBlackboard)Naming.lookup("rmi://"+server.blackboardHost+":"+server.blackboardPort+
		           "/"+server.blackboardName);
        } catch (Exception e) {
            e.printStackTrace();
            DialogMessages d=new DialogMessages(parentFrame,true,"Impossibile trovare la blackboard! Assicurarsi che esista");
            d.show();
          }
    }

	Label labelAgent,labelPort,labelMachine;
    TextField textFieldName,textFieldPort,textFieldHost;
    Checkbox checkbox1,checkbox2;
    CheckboxGroup group;
	Button buttonCancel,buttonOk;
}
