import java.awt.*;
import java.awt.event.*;

public class SystemDialog extends Dialog
           implements ActionListener {

    private AgentFrame parentFrame;
    private agentServer server;
    private String name,machine,port;

	public SystemDialog(AgentFrame parent, agentServer server, boolean modal) {
		super(parent, modal);
		parentFrame=parent;
		this.server=server;
		setLayout(null);
		addNotify();
		setSize(getInsets().left + getInsets().right + 643,getInsets().top + getInsets().bottom + 396);
		labelName = new Label("AGENT NAME");
		labelName.setBounds(getInsets().left + 24,getInsets().top + 36,120,20);
		labelName.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelName);
		int index=0;
		for (int i=0;i<server.numberOfAgent;i++) {
		    name=(String)server.otherAgentName.elementAt(i);
		    labelView=new Label(name);
		    labelView.setBounds(getInsets().left + 24,getInsets().top + (84+36*i),144,24);
		    labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		    add(labelView);
		    index=i;
		}
		labelView=new Label(server.nameAgent);
		labelView.setBounds(getInsets().left + 24,getInsets().top + (84+36*(index+1)),144,24);
		labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		add(labelView);
		labelHost = new Label("HOST MACHINE");
		labelHost.setBounds(getInsets().left + 216,getInsets().top + 36,144,20);
		labelHost.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelHost);
		for (int i=0;i<server.numberOfAgent;i++) {
		    machine=(String)server.otherMachine.elementAt(i);
		    labelView=new Label(machine);
		    labelView.setBounds(getInsets().left + 216,getInsets().top + (84+36*i),228,24);
		    labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		    add(labelView);
		    index=i;
		}
		labelView=new Label(server.hostMachine);
		labelView.setBounds(getInsets().left + 216,getInsets().top + (84+36*(index+1)),228,24);
		labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		add(labelView);
		labelPort = new Label("PORT NUMBER");
		labelPort.setBounds(getInsets().left + 456,getInsets().top + 36,132,20);
		labelPort.setFont(new Font("Dialog", Font.BOLD, 16));
		add(labelPort);
		for (int i=0;i<server.numberOfAgent;i++) {
		    port=(String)server.otherRegistry.elementAt(i);
		    labelView=new Label(port);
		    labelView.setBounds(getInsets().left + 480,getInsets().top + (84+36*i),108,24);
		    labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		    add(labelView);
		    index=i;
		}
		labelView=new Label(Integer.toString(server.reg));
		labelView.setBounds(getInsets().left + 480,getInsets().top + (84+36*(index+1)),108,24);
		labelView.setFont(new Font("Dialog", Font.PLAIN, 14));
		add(labelView);
		buttonOk = new Button("Ok");
		buttonOk.addActionListener(this);
		buttonOk.setBounds(getInsets().left + 240,getInsets().top + 324,144,36);
		buttonOk.setFont(new Font("Dialog", Font.BOLD, 16));
		add(buttonOk);
		setTitle("  View the multi-agent system");
	}


    public synchronized void show() {
        Rectangle bounds = parentFrame.getBounds();
    	Rectangle abounds = getBounds();

    	setLocation(bounds.x + (bounds.width - abounds.width)/ 2,
    	     bounds.y + (bounds.height - abounds.height)/2);

    	super.show();
    }

    public void actionPerformed(ActionEvent event) {
	    Object source = event.getSource();
	    if (source == buttonOk) {
	        setVisible(false);
        }
	}

	Label labelName,labelHost,labelPort,labelView;
	Button buttonOk;
}
