/* classe che realizza il server di un agente per la gestione di richieste remote
di consistenza */

import java.awt.*;
import java.io.*;
import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.server.*;
import java.net.InetAddress;
import java.util.Vector;
import amzi.ls.*;

public class agentServer extends UnicastRemoteObject
        implements iAgent {
     int numCall=0;
     String hostMachine=null;
     String nameAgent=null;
     int reg=0;
     String blackboardName=null;
     String blackboardHost=null;
     int blackboardPort=0;
     boolean serverRunning=false,rulesLoaded=false;
     boolean politicaInOut=true;
     Vector otherMachine=new Vector();
     Vector otherRegistry=new Vector();
     Vector otherAgentName=new Vector();
     int numberOfAgent=0;
     String rules=null;
     iBlackboard blackboard;
     AgentFrame referenceFrame=null;

     public agentServer() throws RemoteException {
        super();
        hostMachine=getLocalHost();
     }

/* Metodo remoto invocabile da altre macchine per effettuare il check di consistenza */
     public Vector askRemoteCons(String goal,Vector abdIn) throws RemoteException {
        Vector abdOut=new Vector();
        int id=aggiornaNumCall();
        referenceFrame.printVectorMessage("Ricevuta chiamata N."+id+" di consistenza per il termine '"+goal+"' con Lista_abducibili = ",abdIn);
        try {
          logicAgent lg=new logicAgent(referenceFrame,this,id);
          /* Esecuzione derivazione di consistenza */
          abdOut=lg.askConsLogicAgent(goal,abdIn);
          lg.close();
          if (abdOut.size()>0) {
             referenceFrame.printVectorMessage("Soddisfatta la chiamata N."+id+" di consistenza per il termine '"+goal+"'\nLista di ritorno: ",abdOut);
          } else {
             referenceFrame.printMessage("Fallita la chiamata N."+id+" di consistenza per il termine '"+goal+"'");
          }
        } catch (LSException e) {System.out.println(e.GetMsg());}
        return abdOut;
     }

/* Metodo remoto che effettua il reset del contatore di richieste di consistenza */
     public void remoteResetNumCall() throws RemoteException {
        numCall=0;
        System.out.println("Azzerato numCall sull'agente "+nameAgent);
     }

     public synchronized int aggiornaNumCall() {
        return (numCall++);
     }

     public synchronized void resetNumCall() {
        numCall=0;
     }

     public void setReferenceFrame(AgentFrame af) {
        referenceFrame=af;
     }

     public String getLocalHost() {
        String local=null;
        try {
		  local=InetAddress.getLocalHost().getHostName();
		} catch (Exception e) {System.err.println("Unknown host");e.printStackTrace();}
		return local;
	 }


     public static void main(String args[]) {
        try {
            /* Setting dei riferimenti: il server viene avviato tramite l'istanza
            af di AgentFrame una volta definiti tutti i parametri */
            agentServer as= new agentServer();
            AgentFrame af = new AgentFrame(as);
            af.setVisible(true);
            as.setReferenceFrame(af);
        } catch (Exception e) {e.printStackTrace();}
     }
}


