/* classe che realizza la blackboard condivisa ed implementa i vari tipi di
primitive di accesso */

import java.rmi.*;
import java.rmi.registry.*;
import java.rmi.*;
import java.rmi.server.*;
import java.net.InetAddress;
import amzi.ls.*;

public class blackboard extends UnicastRemoteObject
          implements iBlackboard {

     private String value="[]";
     private boolean available=true;
     String hostMachine=null;
     String name=null;
     int port=0;
     LogicServer ls;


     public blackboard(String name, int port) throws RemoteException {
        super();
        try {
            hostMachine=InetAddress.getLocalHost().getHostName();
        } catch (Exception e) { System.out.println("Host unknown");e.printStackTrace(); }
        this.name=name;
        this.port=port;
        try {
          ls = new LogicServer();
          ls.Init("");
          ls.Load("compatibile");
        } catch (LSException e) {System.out.println(e.GetMsg());}
     }

     public synchronized String In() throws RemoteException {
        while (available==false) {
            try {
                wait();
            } catch (InterruptedException e) {}
        }
        available=false;
        System.out.println("Prelevato l'elemento "+value+" dalla blackboard");
        return value;
     }

     public synchronized void Out(String v) throws RemoteException {
        value=v;
        available=true;
        System.out.println("Inserito l'elemento "+v+" nella blackboard");
        notifyAll();
     }

     public synchronized String read() throws RemoteException {
        System.out.println("Letto l'elemento "+value+" dalla blackboard");
        return value;
     }

     public synchronized boolean write(String v) throws RemoteException {
        long t=0;
        try {
          t=ls.ExecStr("aggiorna_write("+value+","+v+",New)");
        	System.out.println("value = "+value);
        	System.out.println("v = = "+v);
        } catch (LSException e) {System.out.println(e.GetMsg());}
        if (t > 0)
        {
         //System.out.println("La write ha avuto successo");
        	System.out.println("Effettuata la write del nuovo elemento compatibile");
          try {
           long risultato=ls.GetArg(t, 3);  //risultato contiene la lista degli abducibili trovati
           value=ls.TermToStr(risultato,10000);
           System.out.println("Value = "+value);
          } catch (LSException e) {System.out.println(e.GetMsg());}
          return true;
          }
        else
        {
         System.out.println("Nuovo elemento in conflitto con quello presente");
         return false;
        }
     }

     public static void main(String arg[]) {
        int reg=Integer.parseInt(arg[1]);
        try {
            /* Avvio server per la gestione della blackboard */
            LocateRegistry.createRegistry(reg);
            blackboard bb=new blackboard(arg[0],reg);
            Naming.bind("rmi://"+bb.hostMachine+":"+bb.port+"/"+bb.name,bb);
            System.out.println("Blackboard pronta per richieste remote");

        } catch (Exception e) {e.printStackTrace();}
     }
}